// nstesvw.cpp : implementation of the CNstestView class
//

#include "stdafx.h"
#include "nstest.h"

#include "nstesdoc.h"
#include "cntritem.h"
#include "nstesvw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNstestView

IMPLEMENT_DYNCREATE(CNstestView, CView)

BEGIN_MESSAGE_MAP(CNstestView, CView)
	//{{AFX_MSG_MAP(CNstestView)
	ON_WM_SETFOCUS()
	ON_WM_SIZE()
	ON_COMMAND(ID_OLE_INSERT_NEW, OnInsertObject)
	ON_COMMAND(ID_CANCEL_EDIT, OnCancelEdit)
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNstestView construction/destruction

CNstestView::CNstestView()
{
	// TODO: add construction code here
}

CNstestView::~CNstestView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CNstestView drawing

void CNstestView::OnDraw(CDC* pDC)
{
	CNstestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	// TODO: also draw all OLE items in the document
	POSITION rIndex = pDoc->m_Display.FindIndex(GetScrollPos(SB_VERT));
	int iScrollX = GetScrollPos(SB_HORZ);
	
	CSize csExtents;
	int iCumulativeY = 0;
	char *pXOff;
	
	while(rIndex != NULL)	{
		//	Next thing we'll draw.
		pXOff = (char *)(const char *)pDoc->m_Display.GetNext(rIndex);
		
		//	Figure out it's size, and at what X offset we'll actually draw it.
		csExtents = pDC->GetTextExtent(pXOff, strlen(pXOff));
		
		if(iScrollX < (int)strlen(pXOff))	{
			//	Okay to actually draw.
			pXOff += iScrollX;
			pDC->TextOut(0, iCumulativeY, pXOff, strlen(pXOff));
		}
		
		//	Increment our Y value.
		iCumulativeY += csExtents.cy;
	}

	// Draw the selection at an arbitrary position.  This code should be
	//  removed once your real drawing code is implemented.  This position
	//  corresponds exactly to the rectangle returned by CNstestCntrItem,
	//  to give the effect of in-place editing.

	// TODO: remove this code when final draw code is complete.

	if (m_pSelection == NULL)
	{
		POSITION pos = pDoc->GetStartPosition();
		m_pSelection = (CNstestCntrItem*)pDoc->GetNextClientItem(pos);
	}
	if (m_pSelection != NULL)
		m_pSelection->Draw(pDC, CRect(10, 10, 210, 210));
}

void CNstestView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	// TODO: remove this code when final selection model code is written
	m_pSelection = NULL;    // initialize selection 
	
	//	Enable the scroll bars.
	EnableScrollBar(SB_BOTH);
}

void CNstestView::OnUpdate(CView *pSender, LPARAM lHint, CObject *pHint)	{
	CView::OnUpdate(pSender, lHint, pHint);
	
	//	We always know that there is simply another line added.
	//	Anyhow, set some appropriate scroll ranges.	
	CNstestDoc *pDoc = GetDocument();
	int lines = pDoc->m_Display.GetCount();
	int lastwidth = (int)lHint;	//	Width of the new line added.
	
	int iCurMin, iCurMax;
	GetScrollRange(SB_HORZ, &iCurMin, &iCurMax);
	if(iCurMax < lastwidth)	{
		SetScrollRange(SB_HORZ, 0, lastwidth);
	}
	
	SetScrollRange(SB_VERT, 0, lines);	
}

/////////////////////////////////////////////////////////////////////////////
// CNstestView printing

BOOL CNstestView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CNstestView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CNstestView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// OLE Client support and commands

BOOL CNstestView::IsSelected(const CObject* pDocItem) const
{
	// The implementation below is adequate if your selection consists of
	//  only CNstestCntrItem objects.  To handle different selection
	//  mechanisms, the implementation here should be replaced.

	// TODO: implement this function that tests for a selected OLE client item

	return pDocItem == m_pSelection;
}

void CNstestView::OnInsertObject()
{
	// Invoke the standard Insert Object dialog box to obtain information
	//  for new CNstestCntrItem object.
	COleInsertDialog dlg;
	if (dlg.DoModal() != IDOK)
		return;

	BeginWaitCursor();

	CNstestCntrItem* pItem = NULL;
	TRY
	{
		// Create new item connected to this document.
		CNstestDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);
		pItem = new CNstestCntrItem(pDoc);
		ASSERT_VALID(pItem);

		// Initialize the item from the dialog data.
		if (!dlg.CreateItem(pItem))
			AfxThrowMemoryException();  // any exception will do
		ASSERT_VALID(pItem);

		// If item created from class list (not from file) then launch
		//  the server to edit the item.
		if (dlg.GetSelectionType() == COleInsertDialog::createNewItem)
			pItem->DoVerb(OLEIVERB_SHOW, this);

		ASSERT_VALID(pItem);

		// As an arbitrary user interface design, this sets the selection
		//  to the last item inserted.

		// TODO: reimplement selection as appropriate for your application

		m_pSelection = pItem;   // set selection to last inserted item
		pDoc->UpdateAllViews(NULL);
	}
	CATCH(CException, e)
	{
		if (pItem != NULL)
		{
			ASSERT_VALID(pItem);
			pItem->Delete();
		}
		AfxMessageBox(IDP_FAILED_TO_CREATE);
	}
	END_CATCH

	EndWaitCursor();
}

// The following command handler provides the standard keyboard
//  user interface to cancel an in-place editing session.
void CNstestView::OnCancelEdit()
{
	// Close any in-place active item on this view.
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pActiveItem != NULL)
	{
		pActiveItem->Close();
	}
	ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
}

// Special handling of OnSetFocus and OnSize are required for a container
//  when an object is being edited in-place.
void CNstestView::OnSetFocus(CWnd* pOldWnd)
{
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pActiveItem != NULL &&
		pActiveItem->GetItemState() == COleClientItem::activeUIState)
	{
		// need to set focus to this item if it is in the same view
		CWnd* pWnd = pActiveItem->GetInPlaceWindow();
		if (pWnd != NULL)
		{
			pWnd->SetFocus();   // don't call the base class
			return;
		}
	}

	CView::OnSetFocus(pOldWnd);
}

void CNstestView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pActiveItem != NULL)
		pActiveItem->SetItemRects();
}

/////////////////////////////////////////////////////////////////////////////
// CNstestView diagnostics

#ifdef _DEBUG
void CNstestView::AssertValid() const
{
	CView::AssertValid();
}

void CNstestView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CNstestDoc* CNstestView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CNstestDoc)));
	return (CNstestDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CNstestView message handlers

void CNstestView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	CView::OnHScroll(nSBCode, nPos, pScrollBar);
	
	int iCurX = GetScrollPos(SB_HORZ);
	int iMinX, iMaxX;
	GetScrollRange(SB_HORZ, &iMinX, &iMaxX);
	
	switch(nSBCode)	{
	case SB_LEFT:
		iCurX = 0;
		break;
	case SB_ENDSCROLL:
		//	whatever...
		break;
	case SB_LINELEFT:
		iCurX--;
		break;
	case SB_LINERIGHT:
		iCurX++;
		break;
	case SB_PAGELEFT:
		iCurX -= 10;
		break;
	case SB_PAGERIGHT:
		iCurX += 10;
		break;
	case SB_RIGHT:
		iCurX = 0x7FFF;
		break;
	case SB_THUMBPOSITION:
		iCurX = nPos;
		break;
	case SB_THUMBTRACK:
		iCurX = nPos;
		break;
	}
	
	if(iCurX < iMinX)	{
		iCurX = iMinX;
	}
	if(iCurX > iMaxX)	{
		iCurX = iMaxX;
	}
	
	SetScrollPos(SB_HORZ, iCurX);
	Invalidate();
}

void CNstestView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default	
	CView::OnVScroll(nSBCode, nPos, pScrollBar);
	
	int iCurY = GetScrollPos(SB_VERT);
	int iMinY, iMaxY;
	GetScrollRange(SB_VERT, &iMinY, &iMaxY);
	
	switch(nSBCode)	{
	case SB_TOP:
		iCurY = 0;
		break;
	case SB_ENDSCROLL:
		//	whatever...
		break;
	case SB_LINEUP:
		iCurY--;
		break;
	case SB_LINEDOWN:
		iCurY++;
		break;
	case SB_PAGEUP:
		iCurY -= 10;
		break;
	case SB_PAGEDOWN:
		iCurY += 10;
		break;
	case SB_BOTTOM:
		iCurY = 0x7FFF;
		break;
	case SB_THUMBPOSITION:
		iCurY = nPos;
		break;
	case SB_THUMBTRACK:
		iCurY = nPos;
		break;
	}
	
	if(iCurY < iMinY)	{
		iCurY = iMinY;
	}
	if(iCurY > iMaxY)	{
		iCurY = iMaxY;
	}
	
	SetScrollPos(SB_VERT, iCurY);
	Invalidate();
}
